<div id="dasboard-projet" class="container-fluid d-flex flex-column">
  <div class="accordion accordion-flush" id="accordionFlushExample">
    <div class="accordion-item ">
      <h2 class="accordion-header" id="flush-heading{{ projet.id }}">
        <button class="accordion-button collapsed d-flex flex-row justify-content-between align-items-center"
                type="button" data-bs-toggle="collapse"
                [attr.data-bs-target]="'#flush-collapse' +
                projet.id " aria-expanded="false"
                [attr.aria-controls]="'flush-collapse' +
                projet.id ">
          <div class="d-flex flex-row flex-grow-1 d-flex align-items-center">
            <span *ngIf="!projet.archive" class="actif status d-flex align-items-center" >actif</span>
            <span *ngIf="projet.archive" class="inactif status d-flex align-items-center" >inactif</span>
            <!--<span class="plan-title d-flex align-items-center">{{ (plan.nom.length>25)? (plan.nom | slice:0:25)+'...':(plan.nom) }}</span>-->
            <span class="plan-title d-flex align-items-center me-3" (click)="navigateTo('projet', projet)">{{ projet.nom }}</span><span class="version me-1">v.{{ projet.version }}</span>
          </div>
          <div class="d-flex flex-row">
            <div *ngIf="projet?.bugs?.length != 0 || testsObsoletes(projet)?.length != 0" class="projet-alert d-flex align-items-center bg-danger me-2">i</div>
            <app-add-to-favorites-popup></app-add-to-favorites-popup>
          </div>
        </button>
      </h2>
      <div id="flush-collapse{{ projet.id }}" class="accordion-collapse collapse"
           [attr.aria-labelledby]="'flush-heading' +
           projet.id "
           data-bs-parent="#accordionFlushExample">
        <div class="accordion-body ">
          <div class="accordion accordion-flush" id="accordionFlushExample1">
            <div id="plan{{ projet.id }}"
                 class="accordion-item plan" >
              <h2 class="accordion-header" id="flush-headingPlan{{ projet.id }}">
                <button (click)="generateCharts(projet)" class="accordion-button liste-projet d-flex flex-column align-items-start collapsed p-0 pt-2 pb-2 pe-1 ps-4"
                        type="button"
                        data-bs-toggle="collapse"
                        aria-expanded="false"
                        [attr.data-bs-target]="'#flush-collapsePlan' + projet.id"
                        [attr.aria-controls]="'flush-collapsePlan' + projet.id" click-stop-propagation>
                  <h3>DETAILS</h3>
                  <h4>{{ projet.nom }} - <span>{{ utilisateur.nom }}</span></h4>
                  <p>{{ projet.details }}</p>
                </button>
              </h2>
            </div>
          </div>
        </div>
        <div id="flush-collapsePlan{{ projet.id }}"
             class="accordion-collapse liste-projet collapse"
             [attr.aria-labelledby]="'flush-headingPlan' + projet.id"
             data-bs-parent="#accordionFlushExample1">
          <div class="accordion-body liste-projet">
            <div class="accordion accordion-flush" id="accordionFlushExample2">
              <div class="accordion-item ">
                <h2  class="accordion-header" id="flush-heading{{ projet.id }}" >
                  <div class="chiffres-cle d-flex flex-row w-100 p-2" >
                    <div class="left-content d-flex flex-column w-50">
                      <span *ngIf="getTestsEchec(projet).length  == 0" class="chiffres-item bugs non-resolus green" style="cursor: pointer;" (click)="onClick($event, projet)">Aucun bug non résolu</span>
                      <span *ngIf="getTestsEchec(projet).length  == 1" class="chiffres-item bugs non-resolus red" style="cursor: pointer;" (click)="onClick($event, projet)">{{ getTestsEchec(projet).length }} bug non résolu dont {{ bugsCritiques(projet).length }} critique</span>
                      <span *ngIf="getTestsEchec(projet).length  !=0 && projet?.bugs?.length != 1" class="chiffres-item bugs non-resolus red" style="cursor: pointer;" (click)="onClick($event, projet)">{{ getTestsEchec(projet).length  }} bugs non résolus dont {{ bugsCritiques(projet).length }} critique(s)</span>
                      <span *ngIf="testsObsoletes(projet)?.length == 0" class="chiffres-item tests obsoletes green">Aucun test obsolète</span>
                      <span *ngIf="testsObsoletes(projet)?.length != 0" class="chiffres-item tests obsoletes red" style="cursor: pointer;" (click)="onShowTestsObsoletes($event, projet)">{{ testsObsoletes(projet)?.length }} tests obsolètes</span>
                      <span class="chiffres-item plans total" style="cursor: pointer;" (click)="onShowTestsPlans($event, projet)">{{ projet?.testPlans?.length }} plan(s) de tests</span>
                      <span class="chiffres-item bugs total" style="cursor: pointer;" (click)="onShowGroupesFonctionnalites($event, projet)">{{ getGroupesFonctionnalites(projet).length }} groupe(s) de fonctionnalité(s)</span>
                      <span class="chiffres-item fonctionnalites total" style="cursor: pointer;" (click)="onShowFonctionnalites($event, projet)">{{ getFonctionnalites(projet).length }} fonctionnalités</span>
                    </div>
                    <div class="right-content d-flex flex-column w-50">
                      <span *ngIf="getBugsNonAttribues(projet).length == 0" class="chiffres-item bugs non-attribues green" style="cursor: pointer;" (click)="onShowBugsNonAttribues($event, projet)">Aucun bug non attribué</span>
                      <span *ngIf="getBugsNonAttribues(projet).length != 0" class="chiffres-item bugs non-attribues red" style="cursor: pointer;" (click)="onShowBugsNonAttribues($event, projet)">{{ getBugsNonAttribues(projet).length }} bugs non attribués</span>
                     </div>
                  </div>
                  <div id="graphs" class="d-flex flex-row justify-content-center" >
                    <div id="version-actuelle" class="d-flex flex-column justify-content-center" *ngIf="projet.id && projet.bugs">
                      <!-- saleData -->
                      <ngx-charts-advanced-pie-chart
                        [results]="versionActuelle[projet.id]"
                        [gradient]="true"
                        [view]="[600,200]">
                      </ngx-charts-advanced-pie-chart>
                      <span class="my-chart-title fs-5 ps-3">BUGS PAR NIVEAU DE CRITICITE</span>
                    </div>
                    <div id="version-actuelle" class="d-flex flex-column justify-content-center me-5" *ngIf="projet.id && !projet.bugs">
                      <!-- saleData -->
                      <ngx-charts-advanced-pie-chart
                        [results]="versionActuelle[projet.id]"
                        [gradient]="true"
                        [view]="[200,200]">
                      </ngx-charts-advanced-pie-chart>
                      <span class="my-chart-title fs-5 ps-3 ms-2">BUGS PAR NIVEAU DE CRITICITE</span>
                    </div>
                    <div id="toutes-versions" class="d-flex flex-column justify-content-center" *ngIf="projet.id && getFonctionnalites(projet).length">
                      <!-- saleData -->
                      <ngx-charts-advanced-pie-chart
                        [results]="toutesVersions[projet.id]"
                        [gradient]="true"
                        [view]="[600,200]">
                      </ngx-charts-advanced-pie-chart>
                      <span class="my-chart-title fs-5 ps-3">RESULTATS DES TESTS</span>
                    </div>
                    <div id="toutes-versions" class="d-flex flex-column justify-content-center me-5" *ngIf="projet.id && !getFonctionnalites(projet).length">
                      <!-- saleData -->
                      <ngx-charts-advanced-pie-chart
                        [results]="toutesVersions[projet.id]"
                        [gradient]="true"
                        [view]="[200,200]">
                      </ngx-charts-advanced-pie-chart>
                      <span class="my-chart-title fs-5 ps-3 ms-2">RESULTATS DES TESTS</span>
                    </div>
                  </div>
                </h2>
              </div>
            </div>
          </div>
        </div>
        <div class="accordion-body-bottom "></div>
      </div>
    </div>
  </div>

</div>


<!-- modal -->
<!-- Modal list bugs-->
<div class="modal" id="myModal" [style.display]="showModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Bugs non résolus :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let bug of projetBugs" class="d-flex flex-row justify-content-between">
          <div class="d-flex flex-row">
            <span class="bug-obsolete d-flex flex-row align-items-center me-3"><span class="ellipsis">{{ bug.fonctionnalite?.nom }}</span></span>
            <span *ngIf="bug.date">-</span>
            <span class="date me-3 ms-3 d-flex flex-row align-items-center">{{ bug.date | date:'d/MM/yy, h:mm':'fr'}}</span>
          </div>
          <span *ngIf="!bug.assigne_a_utilisateur_id" class="assign-to d-flex flex-row align-items-center" style="cursor: pointer;" (click)="onAssignTo($event, bug)">+</span>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- modal -->
<!-- Modal Assign To-->
<div class="modal" id="assignToModal" [style.display]="showAssignModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Assigner Bug :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('assignToModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <form #assignToForm="ngForm">
          <div class="form-control" *ngIf="projetDevs">
            <select name="assignToDev" id="assignToDev" class="w-100 form-control" ngModel>
              <option value="" [selected]>Choisissez un Développeur</option>
              <option *ngFor="let membre of projetDevs" [ngValue]="membre">{{ membre.prenom }} {{ membre.nom }}</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="assignTo(assignToForm.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal list tests obsolètes-->
<div class="modal" id="testsObsoletesModal" [style.display]="showTestsObsoletesModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Tests Obsolètes :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('testsObsoletes')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let test of projetTestsObsoletes" class="d-flex flex-row justify-content-between" style="cursor: pointer;" (click)="navigateTo('groupe', test)">
          <div class="d-flex flex-row">
            <span class="bug-obsolete d-flex flex-row align-items-center me-3"><span class="ellipsis">{{ test.nom}}</span></span>
            -
            <span *ngIf="test.testee" class="date me-3 ms-3 d-flex flex-row align-items-center">{{ test.testee | date:'d/MM/yy, h:mm':'fr'}}</span>
            <span *ngIf="!test.testee" class="date me-3 ms-3 d-flex flex-row align-items-center">Non exécuté</span>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal list testplans-->
<div class="modal" id="testsPlansModal" [style.display]="showTestsPlansModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Plans de Tests :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('testsPlans')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let plan of projetTestPlans" class="d-flex flex-row" style="cursor: pointer;" (click)="navigateTo('testplans', plan)">
          <span class="bug-obsolete d-flex flex-row align-items-center me-3"><span class="ellipsis long">{{ plan.nom}}</span></span>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal list groupes fonctionnalites-->
<div class="modal" id="groupesFonctionnalitesModal" [style.display]="showGroupesFonctionnalitesModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Groupes de Fonctionnalités :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('groupesFonctionnalites')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let groupe of projetGroupesFonctionnalites" class="d-flex flex-row" style="cursor: pointer;" (click)="navigateTo('groupeFonctionnalite', groupe)">
          <span class="bug-obsolete d-flex flex-row align-items-center me-3"><span class="ellipsis long">{{ groupe.nom}}</span></span>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal list Fonctionnalites-->
<div class="modal" id="fonctionnalitesModal" [style.display]="showfonctionnalitesModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Fonctionnalites :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('fonctionnalites')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let fonctionnalite of projetFonctionnalites" class="d-flex flex-row" style="cursor: pointer;" (click)="navigateTo('groupe', fonctionnalite)">
          <span class="bug-obsolete d-flex flex-row align-items-center me-3"><span class="ellipsis long">{{ fonctionnalite.nom}}</span></span>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- modal -->
<!-- Modal list bugs-->
<div class="modal" id="bugsNonAttribuesModal" [style.display]="showbugsNonAttribuesModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Bugs non Attribués :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('bugsNonAttribuesModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let bug of projetBugsNonAttribues" class="d-flex flex-row justify-content-between">
          <div class="d-flex flex-row">
            <span class="bug-obsolete d-flex flex-row align-items-center me-3"><span class="ellipsis">{{ bug.fonctionnalite?.nom }}</span></span>
            <span *ngIf="bug.date">-</span>
            <span class="date me-3 ms-3 d-flex flex-row align-items-center">{{ bug.date | date:'d/MM/yy, h:mm':'fr'}}</span>
          </div>
          <span *ngIf="!bug.assigne_a_utilisateur_id" class="assign-to d-flex flex-row align-items-center" style="cursor: pointer;" (click)="onAssignTo($event, bug)">+</span>
        </div>
        <span *ngIf="projetBugsNonAttribues?.length == 0">Aucun bug à assigner</span>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>



<!-- modal -->
<!-- Modal Assign To-->
<div class="modal" id="assignToModalB" [style.display]="showAssignModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Assigner Bug :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('assignToModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <form #assignToFormB="ngForm">
          <div class="form-control" *ngIf="projetDevs">
            <select name="assignToDev" id="assignToDev" class="w-100 form-control" ngModel>
              <option value="" [selected]>Choisissez un Développeur</option>
              <option *ngFor="let membre of projetDevs" [ngValue]="membre">{{ membre.prenom }} {{ membre.nom }}</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="assignToB(assignToFormB.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- modal -->
<!-- Modal list chefs projet-->
<div class="modal" id="chefsProjetModal" [style.display]="showChefsProjetModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Chefs Projet :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('showChefsProjetModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let chef of chefsProjet" class="d-flex flex-row justify-content-between">
          <div class="d-flex flex-row">
            <span class="bug-obsolete d-flex flex-row align-items-center me-2"><span class="ellipsis long">{{ chef.prenom }} {{ chef.nom }}</span></span>
           </div>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- modal -->
<!-- Modal list devs-->
<div class="modal" id="devsProjetModal" [style.display]="showDevsProjetModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Développeurs Projet :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('showDevsProjetModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let dev of devsProjet" class="d-flex flex-row justify-content-between">
          <div class="d-flex flex-row">
            <span class="bug-obsolete d-flex flex-row align-items-center me-2"><span class="ellipsis long">{{ dev.prenom }} {{ dev.nom }}</span></span>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- modal -->
<!-- Modal list betas-->
<div class="modal" id="betasProjetModal" [style.display]="showbetasProjetModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Betas Testeurs Projet :</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('showbetasProjetModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body d-flex flex-column">
        <div *ngFor="let beta of betasProjet" class="d-flex flex-row justify-content-between">
          <div class="d-flex flex-row">
            <span class="bug-obsolete d-flex flex-row align-items-center me-2"><span class="ellipsis long">{{ beta.prenom }} {{ beta.nom }}</span></span>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>


<!-- Modal DELETE Plan-->
<div class="modal" id="deleteModal" [style.display]="showDeleteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Archiver : {{deleteMembre?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('deleteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <div class="form-group">
          <p  class="mt-3 mb-5" >Vous êtes sur le point d'activer le projet {{deleteMembre?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
        </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-danger w-100" (click)="onDelete($event, deleteMembre)" data-dismiss="modal">Désactiver</button>
          </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; ; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>


